diff --git a/Documentation/ABI/testing/sysfs-bus-mdio b/Documentation/ABI/testing/sysfs-bus-mdio
index 38be04dfc05e..a1fad1d0b8fa 100644
--- a/Documentation/ABI/testing/sysfs-bus-mdio
+++ b/Documentation/ABI/testing/sysfs-bus-mdio
@@ -1,72 +1,72 @@
-What:          /sys/bus/mdio_bus/devices/.../statistics/
+What:          /sys/bus/mdio/devices/.../statistics/
 What:          /sys/class/mdio_bus/.../statistics/
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		This folder contains statistics about global and per
 		MDIO bus address statistics.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/transfers
+What:          /sys/bus/mdio/devices/.../statistics/transfers
 What:          /sys/class/mdio_bus/.../transfers
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of transfers for this MDIO bus.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/errors
+What:          /sys/bus/mdio/devices/.../statistics/errors
 What:          /sys/class/mdio_bus/.../statistics/errors
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of transfer errors for this MDIO bus.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/writes
+What:          /sys/bus/mdio/devices/.../statistics/writes
 What:          /sys/class/mdio_bus/.../statistics/writes
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of write transactions for this MDIO bus.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/reads
+What:          /sys/bus/mdio/devices/.../statistics/reads
 What:          /sys/class/mdio_bus/.../statistics/reads
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of read transactions for this MDIO bus.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/transfers_<addr>
+What:          /sys/bus/mdio/devices/.../statistics/transfers_<addr>
 What:          /sys/class/mdio_bus/.../statistics/transfers_<addr>
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of transfers for this MDIO bus address.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/errors_<addr>
+What:          /sys/bus/mdio/devices/.../statistics/errors_<addr>
 What:          /sys/class/mdio_bus/.../statistics/errors_<addr>
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of transfer errors for this MDIO bus address.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/writes_<addr>
+What:          /sys/bus/mdio/devices/.../statistics/writes_<addr>
 What:          /sys/class/mdio_bus/.../statistics/writes_<addr>
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of write transactions for this MDIO bus address.
 
-What:          /sys/bus/mdio_bus/devices/.../statistics/reads_<addr>
+What:          /sys/bus/mdio/devices/.../statistics/reads_<addr>
 What:          /sys/class/mdio_bus/.../statistics/reads_<addr>
-Date:          January 2020
-KernelVersion: 5.6
+Date:          January 2025
+KernelVersion: 6.13
 Contact:       netdev@vger.kernel.org
 Description:
 		Total number of read transactions for this MDIO bus address.
diff --git a/drivers/net/phy/mdio_bus.c b/drivers/net/phy/mdio_bus.c
index 7e2f10182c0c..20dd59208973 100644
--- a/drivers/net/phy/mdio_bus.c
+++ b/drivers/net/phy/mdio_bus.c
@@ -1425,7 +1425,7 @@ static const struct attribute_group *mdio_bus_dev_groups[] = {
 };
 
 const struct bus_type mdio_bus_type = {
-	.name		= "mdio_bus",
+	.name		= "mdio",
 	.dev_groups	= mdio_bus_dev_groups,
 	.match		= mdio_bus_match,
 	.uevent		= mdio_uevent,